

/*
D:\Dev_Cpp
D:\Dev_Cpp\Graf_Fraktal2

STANDARD 480 * 800?
Speicherort 
D:\Dev_Cpp
MinGW erneuern

https://www.tutorials.de/threads/grafiken-zeichnen-in-der-konsole.194602/
https://sourceforge.net/projects/orwelldevcpp/files/Compilers/MinGW/

libgdi32.a mit dazulinken:
Unter Projektoptionen->Parameter->Linker whlst du aus dem lib Verzeichnis von DevCpp einfach die o.g. lib aus.

libgdi32.a liegt Bsp: zugleich als 64 und 32 Bit version unter
C:\Program Files (x86)\Dev-Cpp\MinGW64\x86_64-w64-mingw32\lib
C:\Program Files (x86)\Dev-Cpp\MinGW64\x86_64-w64-mingw32\lib32

*/

#pragma comment(lib,"libgdi32.a")   // einbinden von lib

#include <windows.h>
#include <iostream>
#include <limits>
#include <stdexcept>
using namespace std;

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <math.h>

#include "main.h"
//#include <time.h>

//FENSTER PIXEL GROESSE
// ------------------------
#define WINX_WIDTH 1024
#define WINY_WIDTH 1024
// ------------------------
#define COULOUR_MAX_VAL	0xFFFFFF


//#define ITERATION_MAX  10000UL
#define ITERATION_MAX 1000UL

#define X_MIN 			-1.6
#define X_WIDTH			2.8

#define Y_MIN 			-1.5
#define Y_WIDTH			3.0

//GLOBAL
HWND hWnd;
HDC hDC;
unsigned long IterationMax  = ITERATION_MAX;
unsigned char u8Rot, u8Gruen, u8Blau;
uint32_t u32IterBerechnungMax = 0;

//Fraktalberechnung
// ****************************************************************
void Fraktal( double fX_Min, double fX_Width,double fY_Min, double fY_Width, uint32_t u32IterMax )
// ****************************************************************
{
	//ANFANG
//http://warp.povusers.org/Mandelbrot/

uint8_t u8Event = 0;

uint16_t u16XX;
uint16_t u16YY;
uint32_t u32IterNN;

float fIterCoulourquotient;
uint32_t u32Coulour;

double fRN;
double fIN;

double fR_Z2;
double fI_Z2;

double fBetrag;
double fINC_X; //OFFSET
double fINC_Y; //OFFSET
double fXC;
double fYC; 
//float  _Complex a = 1;

system("cls"); 

fINC_X = fX_Width / WINY_WIDTH; 	//OFFSET
fINC_Y = fY_Width / WINX_WIDTH ; //OFFSET

fXC = fX_Min;
fYC = fY_Min;
// Zn+1= Z^2 + C
for( u16YY = 0 ; u16YY < WINY_WIDTH ; u16YY++)	
	{
	for( u16XX = 0 ; u16XX < WINX_WIDTH ; u16XX++)
		{

		u32IterNN=0;
		fRN = 0; // Z=0
		fIN = 0;
		fR_Z2 = 0;	//RZ^2
		fI_Z2 = 0;	//IZ^2
		//u8Event &= ~ITERATION_ENDE;	
		do{
			//Z = fRN * fRN + 2 fRN*fIN - fIN*fIN;  //BINOM
//diese Zeile vorher da fin Rekursiv zugewissen ist und fRN sonst berschrieben wre.
			//X^2 - y^2 +  i( 2*XY )  
			//inclusive Rckkopplung	
			// (fIN * fRN * 2 ) + fYC;		//2*XY +Ci --  
			fIN	= (2 * fRN * fIN ) + fYC;	//2*XY +Ci --   vorgezogen weil fIn sonst berschrieben 
			fRN = fR_Z2 - fI_Z2  + fXC;	   // X2 - y2 +  Cr    i( 2*XY )
			fR_Z2 = fRN * fRN;		//SPEICHERE IN QUADRAT weil oft gebraucht RZ^2
			fI_Z2 =  fIN * fIN;		//SPEICHERE IN QUADRAT RZ^2

			if( ((fR_Z2) + (fI_Z2 )) >= 4.0 ) // BETRAG = SQR( RZ^2 + IZ^2
				{					
				if( u32IterBerechnungMax < u32IterNN ) 
					{
					u32IterBerechnungMax = u32IterNN;  // Merk hchsten wert
					};
				u32Coulour = round( (((double)u32IterNN)/ ((double)u32IterMax  )) * ((double)COULOUR_MAX_VAL));
								
				u8Rot =  (unsigned char)(u32Coulour & 0xFF );
				u8Gruen =  (unsigned char)(u32Coulour >> 8) & 0xFF; 
				u8Blau  =   (unsigned char)(u32Coulour >> 16) & 0xFF;
				SetPixel(hDC, u16XX, u16YY, RGB(u8Rot, u8Gruen, u8Blau));					
				//SetPixel(hDC, u16XX, u16YY, u32Coulour);					
				break;
				}
			
			}while( (u32IterNN++) < u32IterMax );		
		fXC += fINC_X;
		};
		
	fXC = fX_Min;  //Weider auf Anfang stellen
	fYC += fINC_Y;
	};	
};


int main(void)
{
double dX_Min = X_MIN;
double dX_Width = X_WIDTH;
double dY_Min = Y_MIN;
double dY_Width = Y_WIDTH;

SetConsoleTitle("Fraktal in Command Grafik");
    //HWND hWnd = FindWindow(NULL, "Grafik in Dos");
    //alternative zu FindWindow 
hWnd = GetConsoleWindow();
//MoveWindow(hWnd,100,100,windowWidth,windowHeight,FALSE);
if( hWnd != NULL ){ MoveWindow(hWnd ,100,100 ,WINX_WIDTH, WINY_WIDTH ,TRUE); }
//console con( 80, 200 );
/*
SetConsoleScreenBufferSize
SetConsoleWindowInfo
*/
hDC = GetDC(hWnd);       
  
 		dX_Min = -1.8;
		dX_Width = 2.4;
		dY_Min = -1.3;
		dY_Width = 2.6;		
		
		//uint32_t u32IterMax = ITERATION_MAX;
		Fraktal( dX_Min, dX_Width, dY_Min, dY_Width, ITERATION_MAX );
		system("cls"); 
printf("\r\nIterMatMax:%ld",u32IterBerechnungMax);
		//u32IterBerechnungMax
		Fraktal( dX_Min, dX_Width, dY_Min, dY_Width, u32IterBerechnungMax );
printf("\r\nIterMatMax:%ld",u32IterBerechnungMax);
	ReleaseDC(hWnd, hDC);
    DeleteDC(hDC);
    //std::cin.get();
    system("pause");   
	return 0;        
};/* run this program using the console pauser or add your own getch, system("pause") or input loop */




